(define (domain npc-mp)
  (:requirements :adl :typing :equality)

  (:types
   MAGIC-LAMP - THING
   GENIE - MONSTER
   THIEF - HUMAN
   KNIGHT - HUMAN
   KING - HUMAN
   MONSTER - CHARACTER
   HUMAN - CHARACTER
   PLACE - OBJECT
   THING - OBJECT
   CHARACTER - OBJECT
   COUNT - OBJECT)

  (:predicates
   (INTENTION-COUNT ?WHO - CHARACTER ?C - COUNT)
   (NEXT ?C - COUNT ?C-NEXT - COUNT)
   (ALIVE ?WHO - CHARACTER)
   (DEAD ?WHO - CHARACTER)
   (AT ?WHO - CHARACTER ?WHERE - PLACE)
   (UNCONFINED ?WHO - CHARACTER)
   (HAS ?WHO - CHARACTER ?WHAT - THING)
   (WAS-STOLEN-FROM ?WHO - CHARACTER ?WHAT - THING)
   (VALUES-MORE-THAN ?WHO - CHARACTER ?WHAT-MORE - THING ?WHAT-LESS -
       THING)
   (LOVES ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (SINGLE ?WHO - HUMAN)
   (MARRIED ?WHO - HUMAN)
   (MARRIED-TO ?WHO - HUMAN ?WHO-ELSE - HUMAN)
   (LOYAL-TO ?KING - KING ?KNIGHT - KNIGHT)
   (BEAUTIFUL ?WHO - HUMAN)
   (SCARY ?WHO - MONSTER)
   (CONTROLS ?WHO - CHARACTER ?GEN - GENIE)
   (IN ?GEN - GENIE ?LAMP - MAGIC-LAMP)
   (INTENDS-MARRIED-TO ?INTENDS-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE
       - HUMAN)
   (INTENDS-LOVES ?INTENDS-WHO - CHARACTER ?WHO - HUMAN ?WHO-ELSE -
       HUMAN)
   (INTENDS-CONTROLS ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?GEN -
       GENIE)
   (INTENDS-HAS ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?WHAT -
       THING)
   (INTENDS-DEAD ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER)
   (INTENDS-AT ?INTENDS-WHO - CHARACTER ?WHO - CHARACTER ?WHERE -
       PLACE))

  (:action TRAVEL-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE
                    ?C-1 - COUNT ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?TRAVELLER ?TRAVELLER ?DEST)
                       (INTENTION-COUNT ?TRAVELLER ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (ALIVE ?TRAVELLER)
                       (AT ?TRAVELLER ?FROM) (UNCONFINED ?TRAVELLER)
                       (NOT (= ?FROM ?DEST)))
    :effect (AND (NOT (INTENDS-AT ?TRAVELLER ?TRAVELLER ?DEST))
                 (NOT (INTENTION-COUNT ?TRAVELLER ?C-1))
                 (INTENTION-COUNT ?TRAVELLER ?C-1-LESS-1)
                 (NOT (AT ?TRAVELLER ?FROM)) (AT ?TRAVELLER ?DEST)))

  (:action PLAN-TO-TRAVEL-1-1-1
    :parameters (?TRAVELLER - CHARACTER ?FROM - PLACE ?DEST - PLACE
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?TRAVELLER ?TRAVELLER ?DEST)
                       (INTENTION-COUNT ?TRAVELLER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?TRAVELLER ?TRAVELLER ?FROM)
                 (NOT (INTENTION-COUNT ?TRAVELLER ?C-1))
                 (INTENTION-COUNT ?TRAVELLER ?C-1-PLUS-1)))

  (:action SLAY-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE ?C-1
                         - COUNT ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?SLAYER ?SLAYEE)
                       (INTENTION-COUNT ?SLAYER ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?SLAYER ?WHERE)
                       (AT ?SLAYEE ?WHERE) (ALIVE ?SLAYER)
                       (ALIVE ?SLAYEE))
    :effect (AND (NOT (INTENDS-DEAD ?SLAYER ?SLAYEE))
                 (NOT (INTENTION-COUNT ?SLAYER ?C-1))
                 (INTENTION-COUNT ?SLAYER ?C-1-LESS-1)
                 (NOT (ALIVE ?SLAYEE)) (DEAD ?SLAYEE)))

  (:action PLAN-TO-SLAY-1-1-2
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE ?C-1
                         - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?SLAYER ?SLAYEE)
                       (INTENTION-COUNT ?SLAYER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?SLAYER ?SLAYEE ?WHERE)
                 (NOT (INTENTION-COUNT ?SLAYER ?C-1))
                 (INTENTION-COUNT ?SLAYER ?C-1-PLUS-1)))

  (:action PLAN-TO-SLAY-1-1-1
    :parameters (?SLAYER - KNIGHT ?SLAYEE - MONSTER ?WHERE - PLACE ?C-1
                         - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?SLAYER ?SLAYEE)
                       (INTENTION-COUNT ?SLAYER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?SLAYER ?SLAYER ?WHERE)
                 (NOT (INTENTION-COUNT ?SLAYER ?C-1))
                 (INTENTION-COUNT ?SLAYER ?C-1-PLUS-1)))

  (:action PILLAGE-1
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING
                    ?WHERE - PLACE ?C-1 - COUNT ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (INTENTION-COUNT ?PILLAGER ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?PILLAGER ?WHERE)
                       (AT ?BODY ?WHERE) (ALIVE ?PILLAGER) (DEAD ?BODY)
                       (HAS ?BODY ?WHAT))
    :effect (AND (NOT (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT))
                 (NOT (INTENTION-COUNT ?PILLAGER ?C-1))
                 (INTENTION-COUNT ?PILLAGER ?C-1-LESS-1)
                 (NOT (HAS ?BODY ?WHAT)) (HAS ?PILLAGER ?WHAT)))

  (:action PLAN-TO-PILLAGE-1-1-4
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (INTENTION-COUNT ?PILLAGER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?PILLAGER ?BODY ?WHAT)
                 (NOT (INTENTION-COUNT ?PILLAGER ?C-1))
                 (INTENTION-COUNT ?PILLAGER ?C-1-PLUS-1)))

  (:action PLAN-TO-PILLAGE-1-1-3
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (INTENTION-COUNT ?PILLAGER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-DEAD ?PILLAGER ?BODY)
                 (NOT (INTENTION-COUNT ?PILLAGER ?C-1))
                 (INTENTION-COUNT ?PILLAGER ?C-1-PLUS-1)))

  (:action PLAN-TO-PILLAGE-1-1-2
    :parameters (?PILLAGER - CHARACTER ?BODY - CHARACTER ?WHAT - THING
                    ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (INTENTION-COUNT ?PILLAGER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?PILLAGER ?BODY ?WHERE)
                 (NOT (INTENTION-COUNT ?PILLAGER ?C-1))
                 (INTENTION-COUNT ?PILLAGER ?C-1-PLUS-1)))

  (:action PLAN-TO-PILLAGE-1-1-1
    :parameters (?PILLAGER - CHARACTER ?WHAT - THING ?WHERE - PLACE
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?PILLAGER ?PILLAGER ?WHAT)
                       (INTENTION-COUNT ?PILLAGER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?PILLAGER ?PILLAGER ?WHERE)
                 (NOT (INTENTION-COUNT ?PILLAGER ?C-1))
                 (INTENTION-COUNT ?PILLAGER ?C-1-PLUS-1)))

  (:action STEAL-1
    :parameters (?THIEF - THIEF ?VICTIM - CHARACTER ?WHAT - THING
                        ?WHERE - PLACE ?C-1 - COUNT ?C-1-LESS-1 -
                        COUNT)
    :precondition (AND (INTENDS-HAS ?THIEF ?THIEF ?WHAT)
                       (INTENTION-COUNT ?THIEF ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?THIEF ?WHERE)
                       (AT ?VICTIM ?WHERE) (ALIVE ?THIEF)
                       (HAS ?VICTIM ?WHAT))
    :effect (AND (NOT (INTENDS-HAS ?THIEF ?THIEF ?WHAT))
                 (NOT (INTENTION-COUNT ?THIEF ?C-1))
                 (INTENTION-COUNT ?THIEF ?C-1-LESS-1)
                 (NOT (HAS ?VICTIM ?WHAT)) (HAS ?THIEF ?WHAT)
                 (WAS-STOLEN-FROM ?VICTIM ?WHAT)))

  (:action PLAN-TO-STEAL-1-1-3
    :parameters (?THIEF - THIEF ?VICTIM - CHARACTER ?WHAT - THING ?C-1
                        - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?THIEF ?THIEF ?WHAT)
                       (INTENTION-COUNT ?THIEF ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?THIEF ?VICTIM ?WHAT)
                 (NOT (INTENTION-COUNT ?THIEF ?C-1))
                 (INTENTION-COUNT ?THIEF ?C-1-PLUS-1)))

  (:action PLAN-TO-STEAL-1-1-2
    :parameters (?THIEF - THIEF ?VICTIM - CHARACTER ?WHAT - THING
                        ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                        COUNT)
    :precondition (AND (INTENDS-HAS ?THIEF ?THIEF ?WHAT)
                       (INTENTION-COUNT ?THIEF ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?THIEF ?VICTIM ?WHERE)
                 (NOT (INTENTION-COUNT ?THIEF ?C-1))
                 (INTENTION-COUNT ?THIEF ?C-1-PLUS-1)))

  (:action PLAN-TO-STEAL-1-1-1
    :parameters (?THIEF - THIEF ?WHAT - THING ?WHERE - PLACE ?C-1 -
                        COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?THIEF ?THIEF ?WHAT)
                       (INTENTION-COUNT ?THIEF ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?THIEF ?THIEF ?WHERE)
                 (NOT (INTENTION-COUNT ?THIEF ?C-1))
                 (INTENTION-COUNT ?THIEF ?C-1-PLUS-1)))

  (:action GIVE-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING
                        ?WHERE - PLACE ?C-1 - COUNT ?C-1-LESS-1 -
                        COUNT)
    :precondition (AND (INTENDS-HAS ?GIVER ?GIVEE ?WHAT)
                       (INTENTION-COUNT ?GIVER ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?GIVER ?WHERE)
                       (AT ?GIVEE ?WHERE) (ALIVE ?GIVER) (ALIVE ?GIVEE)
                       (HAS ?GIVER ?WHAT) (NOT (= ?GIVER ?GIVEE)))
    :effect (AND (NOT (INTENDS-HAS ?GIVER ?GIVEE ?WHAT))
                 (NOT (INTENTION-COUNT ?GIVER ?C-1))
                 (INTENTION-COUNT ?GIVER ?C-1-LESS-1)
                 (NOT (HAS ?GIVER ?WHAT)) (HAS ?GIVEE ?WHAT)))

  (:action PLAN-TO-GIVE-1-1-3
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING
                        ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?GIVER ?GIVEE ?WHAT)
                       (INTENTION-COUNT ?GIVER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?GIVER ?GIVER ?WHAT)
                 (NOT (INTENTION-COUNT ?GIVER ?C-1))
                 (INTENTION-COUNT ?GIVER ?C-1-PLUS-1)))

  (:action PLAN-TO-GIVE-1-1-2
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING
                        ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                        COUNT)
    :precondition (AND (INTENDS-HAS ?GIVER ?GIVEE ?WHAT)
                       (INTENTION-COUNT ?GIVER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GIVER ?GIVEE ?WHERE)
                 (NOT (INTENTION-COUNT ?GIVER ?C-1))
                 (INTENTION-COUNT ?GIVER ?C-1-PLUS-1)))

  (:action PLAN-TO-GIVE-1-1-1
    :parameters (?GIVER - CHARACTER ?GIVEE - CHARACTER ?WHAT - THING
                        ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                        COUNT)
    :precondition (AND (INTENDS-HAS ?GIVER ?GIVEE ?WHAT)
                       (INTENTION-COUNT ?GIVER ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GIVER ?GIVER ?WHERE)
                 (NOT (INTENTION-COUNT ?GIVER ?C-1))
                 (INTENTION-COUNT ?GIVER ?C-1-PLUS-1)))

  (:action TRADE-1
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?WHAT2 - THING ?WHERE - PLACE ?C-1 - COUNT
                    ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?TRADER1 ?WHERE)
                       (AT ?TRADER2 ?WHERE) (ALIVE ?TRADER1)
                       (ALIVE ?TRADER2) (HAS ?TRADER1 ?WHAT1)
                       (HAS ?TRADER2 ?WHAT2)
                       (NOT (VALUES-MORE-THAN ?TRADER1 ?WHAT1 ?WHAT2))
                       (VALUES-MORE-THAN ?TRADER2 ?WHAT1 ?WHAT2)
                       (NOT (= ?TRADER1 ?TRADER2)))
    :effect (AND (NOT (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1))
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-LESS-1)
                 (NOT (HAS ?TRADER1 ?WHAT1))
                 (NOT (HAS ?TRADER2 ?WHAT2)) (HAS ?TRADER2 ?WHAT1)
                 (HAS ?TRADER1 ?WHAT2)))

  (:action TRADE-2
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?WHAT2 - THING ?WHERE - PLACE ?C-1 - COUNT
                    ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?TRADER1 ?WHERE)
                       (AT ?TRADER2 ?WHERE) (ALIVE ?TRADER1)
                       (ALIVE ?TRADER2) (HAS ?TRADER1 ?WHAT1)
                       (HAS ?TRADER2 ?WHAT2)
                       (NOT (VALUES-MORE-THAN ?TRADER1 ?WHAT1 ?WHAT2))
                       (VALUES-MORE-THAN ?TRADER2 ?WHAT1 ?WHAT2)
                       (NOT (= ?TRADER1 ?TRADER2)))
    :effect (AND (NOT (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2))
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-LESS-1)
                 (NOT (HAS ?TRADER1 ?WHAT1))
                 (NOT (HAS ?TRADER2 ?WHAT2)) (HAS ?TRADER2 ?WHAT1)
                 (HAS ?TRADER1 ?WHAT2)))

  (:action PLAN-TO-TRADE-1-2-4
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT2 -
                    THING ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT2)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-2-3
    :parameters (?TRADER1 - CHARACTER ?WHAT1 - THING ?WHAT2 - THING
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT1)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-2-2
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT2 -
                    THING ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                    COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?TRADER1 ?TRADER2 ?WHERE)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-2-1
    :parameters (?TRADER1 - CHARACTER ?WHAT2 - THING ?WHERE - PLACE
                    ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT2)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?TRADER1 ?TRADER1 ?WHERE)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-1-4
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?WHAT2 - THING ?C-1 - COUNT ?C-1-PLUS-1 -
                    COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT2)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-1-3
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?TRADER1 ?TRADER1 ?WHAT1)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-1-2
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                    COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?TRADER1 ?TRADER2 ?WHERE)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action PLAN-TO-TRADE-1-1-1
    :parameters (?TRADER1 - CHARACTER ?TRADER2 - CHARACTER ?WHAT1 -
                    THING ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                    COUNT)
    :precondition (AND (INTENDS-HAS ?TRADER1 ?TRADER2 ?WHAT1)
                       (INTENTION-COUNT ?TRADER1 ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?TRADER1 ?TRADER1 ?WHERE)
                 (NOT (INTENTION-COUNT ?TRADER1 ?C-1))
                 (INTENTION-COUNT ?TRADER1 ?C-1-PLUS-1)))

  (:action SUMMON-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHERE - PLACE ?C-1 - COUNT ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?GEN ?WHERE)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP) (ALIVE ?WHO) (IN ?GEN ?LAMP)
                       (ALIVE ?GEN) (NOT (= ?WHO ?GEN)))
    :effect (AND (NOT (INTENDS-AT ?WHO ?GEN ?WHERE))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (NOT (IN ?GEN ?LAMP)) (AT ?GEN ?WHERE)
                 (UNCONFINED ?GEN) (CONTROLS ?WHO ?GEN)))

  (:action SUMMON-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHERE - PLACE ?C-1 - COUNT ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?WHO ?WHERE)
                       (HAS ?WHO ?LAMP) (ALIVE ?WHO) (IN ?GEN ?LAMP)
                       (ALIVE ?GEN) (NOT (= ?WHO ?GEN)))
    :effect (AND (NOT (INTENDS-CONTROLS ?WHO ?WHO ?GEN))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (NOT (IN ?GEN ?LAMP)) (AT ?GEN ?WHERE)
                 (UNCONFINED ?GEN) (CONTROLS ?WHO ?GEN)))

  (:action PLAN-TO-SUMMON-1-2-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP ?C-1
                      - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-SUMMON-1-2-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHERE - PLACE ?C-1 -
                      COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?WHO ?WHO ?WHERE)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-SUMMON-1-1-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHERE - PLACE ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?GEN ?WHERE)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-SUMMON-1-1-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHERE - PLACE ?C-1 -
                      COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?GEN ?WHERE)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?WHO ?WHO ?WHERE)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action LOVE-SPELL-1
    :parameters (?GEN - GENIE ?TARGET - HUMAN ?LOVER - HUMAN ?C-1 -
                      COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                      ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-LOVES ?GEN ?TARGET ?LOVER)
                       (INTENTION-COUNT ?GEN ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (UNCONFINED ?GEN)
                       (ALIVE ?GEN) (ALIVE ?TARGET) (ALIVE ?LOVER)
                       (NOT (= ?GEN ?TARGET)) (NOT (= ?GEN ?LOVER))
                       (NOT (= ?TARGET ?LOVER))
                       (INTENTION-COUNT ?TARGET ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-LOVES ?GEN ?TARGET ?LOVER))
                 (NOT (INTENTION-COUNT ?GEN ?C-1))
                 (INTENTION-COUNT ?GEN ?C-1-LESS-1)
                 (LOVES ?TARGET ?LOVER)
                 (INTENDS-MARRIED-TO ?TARGET ?TARGET ?LOVER)
                 (NOT (INTENTION-COUNT ?TARGET ?D-2))
                 (INTENTION-COUNT ?TARGET ?D-2-PLUS-1)))

  (:action LOVE-SPELL-2
    :parameters (?GEN - GENIE ?TARGET - HUMAN ?LOVER - HUMAN ?C-1 -
                      COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                      ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GEN ?TARGET ?LOVER)
                       (INTENTION-COUNT ?GEN ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (UNCONFINED ?GEN)
                       (ALIVE ?GEN) (ALIVE ?TARGET) (ALIVE ?LOVER)
                       (NOT (= ?GEN ?TARGET)) (NOT (= ?GEN ?LOVER))
                       (NOT (= ?TARGET ?LOVER))
                       (INTENTION-COUNT ?TARGET ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-MARRIED-TO ?GEN ?TARGET ?LOVER))
                 (NOT (INTENTION-COUNT ?GEN ?C-1))
                 (INTENTION-COUNT ?GEN ?C-1-LESS-1)
                 (LOVES ?TARGET ?LOVER)
                 (INTENDS-MARRIED-TO ?TARGET ?TARGET ?LOVER)
                 (NOT (INTENTION-COUNT ?TARGET ?D-2))
                 (INTENTION-COUNT ?TARGET ?D-2-PLUS-1)))

  (:action MARRY-1-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-LESS-1 - COUNT ?C-1 - COUNT
                        ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1)
                       (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-2)
                       (NEXT ?C-2-LESS-1 ?C-2) (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE) (ALIVE ?GROOM) (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE) (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM) (SINGLE ?BRIDE))
    :effect (AND (NOT (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE))
                 (NOT (INTENTION-COUNT ?BRIDE ?C-1))
                 (INTENTION-COUNT ?BRIDE ?C-1-LESS-1)
                 (NOT (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE))
                 (NOT (INTENTION-COUNT ?GROOM ?C-2))
                 (INTENTION-COUNT ?GROOM ?C-2-LESS-1)
                 (NOT (SINGLE ?GROOM)) (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE)) (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE) (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-1-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-LESS-1 - COUNT ?C-1 - COUNT
                        ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1)
                       (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-2)
                       (NEXT ?C-2-LESS-1 ?C-2) (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE) (ALIVE ?GROOM) (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE) (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM) (SINGLE ?BRIDE))
    :effect (AND (NOT (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM))
                 (NOT (INTENTION-COUNT ?BRIDE ?C-1))
                 (INTENTION-COUNT ?BRIDE ?C-1-LESS-1)
                 (NOT (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE))
                 (NOT (INTENTION-COUNT ?GROOM ?C-2))
                 (INTENTION-COUNT ?GROOM ?C-2-LESS-1)
                 (NOT (SINGLE ?GROOM)) (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE)) (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE) (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-2-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-LESS-1 - COUNT ?C-1 - COUNT
                        ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1)
                       (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-2)
                       (NEXT ?C-2-LESS-1 ?C-2) (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE) (ALIVE ?GROOM) (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE) (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM) (SINGLE ?BRIDE))
    :effect (AND (NOT (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE))
                 (NOT (INTENTION-COUNT ?BRIDE ?C-1))
                 (INTENTION-COUNT ?BRIDE ?C-1-LESS-1)
                 (NOT (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM))
                 (NOT (INTENTION-COUNT ?GROOM ?C-2))
                 (INTENTION-COUNT ?GROOM ?C-2-LESS-1)
                 (NOT (SINGLE ?GROOM)) (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE)) (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE) (MARRIED-TO ?BRIDE ?GROOM)))

  (:action MARRY-2-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-LESS-1 - COUNT ?C-1 - COUNT
                        ?C-1-LESS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1)
                       (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-2)
                       (NEXT ?C-2-LESS-1 ?C-2) (AT ?GROOM ?WHERE)
                       (AT ?BRIDE ?WHERE) (ALIVE ?GROOM) (ALIVE ?BRIDE)
                       (LOVES ?GROOM ?BRIDE) (LOVES ?BRIDE ?GROOM)
                       (SINGLE ?GROOM) (SINGLE ?BRIDE))
    :effect (AND (NOT (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM))
                 (NOT (INTENTION-COUNT ?BRIDE ?C-1))
                 (INTENTION-COUNT ?BRIDE ?C-1-LESS-1)
                 (NOT (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM))
                 (NOT (INTENTION-COUNT ?GROOM ?C-2))
                 (INTENTION-COUNT ?GROOM ?C-2-LESS-1)
                 (NOT (SINGLE ?GROOM)) (MARRIED ?GROOM)
                 (NOT (SINGLE ?BRIDE)) (MARRIED ?BRIDE)
                 (MARRIED-TO ?GROOM ?BRIDE) (MARRIED-TO ?BRIDE ?GROOM)))

  (:action PLAN-TO-MARRY-2-2-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-2 - COUNT ?C-2-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-LOVES ?BRIDE ?BRIDE ?GROOM)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-2-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-2 - COUNT ?C-2-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-LOVES ?BRIDE ?GROOM ?BRIDE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-2-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-AT ?BRIDE ?BRIDE ?WHERE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-2-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-AT ?BRIDE ?GROOM ?WHERE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-1-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-2 - COUNT ?C-2-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-LOVES ?BRIDE ?BRIDE ?GROOM)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-1-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-2 - COUNT ?C-2-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-LOVES ?BRIDE ?GROOM ?BRIDE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-1-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-AT ?BRIDE ?BRIDE ?WHERE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-2-1-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-2 -
                        COUNT ?C-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?BRIDE ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?BRIDE ?C-2)
                       (NEXT ?C-2 ?C-2-PLUS-1))
    :effect (AND (INTENDS-AT ?BRIDE ?GROOM ?WHERE)
                 (NOT (INTENTION-COUNT ?BRIDE ?C-2))
                 (INTENTION-COUNT ?BRIDE ?C-2-PLUS-1)))

  (:action PLAN-TO-MARRY-1-2-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-LOVES ?GROOM ?BRIDE ?GROOM)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-2-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-LOVES ?GROOM ?GROOM ?BRIDE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-2-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-1 -
                        COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GROOM ?BRIDE ?WHERE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-2-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-1 -
                        COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?BRIDE ?GROOM)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GROOM ?GROOM ?WHERE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-1-4
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-LOVES ?GROOM ?BRIDE ?GROOM)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-1-3
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                        - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-LOVES ?GROOM ?GROOM ?BRIDE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-1-2
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-1 -
                        COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GROOM ?BRIDE ?WHERE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action PLAN-TO-MARRY-1-1-1
    :parameters (?GROOM - HUMAN ?BRIDE - HUMAN ?WHERE - PLACE ?C-1 -
                        COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-MARRIED-TO ?GROOM ?GROOM ?BRIDE)
                       (INTENTION-COUNT ?GROOM ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?GROOM ?GROOM ?WHERE)
                 (NOT (INTENTION-COUNT ?GROOM ?C-1))
                 (INTENTION-COUNT ?GROOM ?C-1-PLUS-1)))

  (:action ORDER-AT-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                       CHARACTER ?WHERE-AT - PLACE ?C-1 - COUNT
                       ?C-1-LESS-1 - COUNT ?D-2 - COUNT ?D-2-PLUS-1 -
                       COUNT)
    :precondition (AND (INTENDS-AT ?KING ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE) (ALIVE ?KING)
                       (ALIVE ?KNIGHT) (LOYAL-TO ?KING ?KNIGHT)
                       (INTENTION-COUNT ?KNIGHT ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-AT ?KING ?WHO-AT ?WHERE-AT))
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-LESS-1)
                 (INTENDS-AT ?KNIGHT ?WHO-AT ?WHERE-AT)
                 (NOT (INTENTION-COUNT ?KNIGHT ?D-2))
                 (INTENTION-COUNT ?KNIGHT ?D-2-PLUS-1)))

  (:action PLAN-TO-ORDER-AT-1-1-2
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-AT -
                       CHARACTER ?WHERE-AT - PLACE ?C-1 - COUNT
                       ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?KING ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KNIGHT ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action PLAN-TO-ORDER-AT-1-1-1
    :parameters (?KING - KING ?WHERE - PLACE ?WHO-AT - CHARACTER
                       ?WHERE-AT - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                       COUNT)
    :precondition (AND (INTENDS-AT ?KING ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KING ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action ORDER-DEAD-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD
                       - CHARACTER ?C-1 - COUNT ?C-1-LESS-1 - COUNT
                       ?D-2 - COUNT ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?KING ?WHO-DEAD)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE) (ALIVE ?KING)
                       (ALIVE ?KNIGHT) (LOYAL-TO ?KING ?KNIGHT)
                       (INTENTION-COUNT ?KNIGHT ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-DEAD ?KING ?WHO-DEAD))
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-LESS-1)
                 (INTENDS-DEAD ?KNIGHT ?WHO-DEAD)
                 (NOT (INTENTION-COUNT ?KNIGHT ?D-2))
                 (INTENTION-COUNT ?KNIGHT ?D-2-PLUS-1)))

  (:action PLAN-TO-ORDER-DEAD-1-1-2
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-DEAD
                       - CHARACTER ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?KING ?WHO-DEAD)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KNIGHT ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action PLAN-TO-ORDER-DEAD-1-1-1
    :parameters (?KING - KING ?WHERE - PLACE ?WHO-DEAD - CHARACTER ?C-1
                       - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?KING ?WHO-DEAD)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KING ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action ORDER-HAS-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS
                       - CHARACTER ?WHAT-HAS - THING ?C-1 - COUNT
                       ?C-1-LESS-1 - COUNT ?D-2 - COUNT ?D-2-PLUS-1 -
                       COUNT)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE) (ALIVE ?KING)
                       (ALIVE ?KNIGHT) (LOYAL-TO ?KING ?KNIGHT)
                       (INTENTION-COUNT ?KNIGHT ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-HAS ?KING ?WHO-HAS ?WHAT-HAS))
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-LESS-1)
                 (INTENDS-HAS ?KNIGHT ?WHO-HAS ?WHAT-HAS)
                 (NOT (INTENTION-COUNT ?KNIGHT ?D-2))
                 (INTENTION-COUNT ?KNIGHT ?D-2-PLUS-1)))

  (:action PLAN-TO-ORDER-HAS-1-1-2
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE ?WHO-HAS
                       - CHARACTER ?WHAT-HAS - THING ?C-1 - COUNT
                       ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KNIGHT ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action PLAN-TO-ORDER-HAS-1-1-1
    :parameters (?KING - KING ?WHERE - PLACE ?WHO-HAS - CHARACTER
                       ?WHAT-HAS - THING ?C-1 - COUNT ?C-1-PLUS-1 -
                       COUNT)
    :precondition (AND (INTENDS-HAS ?KING ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KING ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action ORDER-LOVES-1
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE
                       ?WHO-LOVES - HUMAN ?WHO-ELSE-LOVES - HUMAN ?C-1
                       - COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                       ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (AT ?KING ?WHERE)
                       (AT ?KNIGHT ?WHERE) (ALIVE ?KING)
                       (ALIVE ?KNIGHT) (LOYAL-TO ?KING ?KNIGHT)
                       (INTENTION-COUNT ?KNIGHT ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-LOVES ?KING ?WHO-LOVES ?WHO-ELSE-LOVES))
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-LESS-1)
                 (INTENDS-LOVES ?KNIGHT ?WHO-LOVES ?WHO-ELSE-LOVES)
                 (NOT (INTENTION-COUNT ?KNIGHT ?D-2))
                 (INTENTION-COUNT ?KNIGHT ?D-2-PLUS-1)))

  (:action PLAN-TO-ORDER-LOVES-1-1-2
    :parameters (?KING - KING ?KNIGHT - KNIGHT ?WHERE - PLACE
                       ?WHO-LOVES - HUMAN ?WHO-ELSE-LOVES - HUMAN ?C-1
                       - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KNIGHT ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action PLAN-TO-ORDER-LOVES-1-1-1
    :parameters (?KING - KING ?WHERE - PLACE ?WHO-LOVES - HUMAN
                       ?WHO-ELSE-LOVES - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                       - COUNT)
    :precondition (AND (INTENDS-LOVES ?KING ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?KING ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-AT ?KING ?KING ?WHERE)
                 (NOT (INTENTION-COUNT ?KING ?C-1))
                 (INTENTION-COUNT ?KING ?C-1-PLUS-1)))

  (:action COMMAND-AT-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHO-AT - CHARACTER ?WHERE-AT - PLACE ?C-1 -
                      COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                      ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (ALIVE ?WHO)
                       (ALIVE ?GEN) (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN) (NOT (= ?WHO ?GEN))
                       (INTENTION-COUNT ?GEN ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-AT ?WHO ?WHO-AT ?WHERE-AT))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (INTENDS-AT ?GEN ?WHO-AT ?WHERE-AT)
                 (NOT (INTENTION-COUNT ?GEN ?D-2))
                 (INTENTION-COUNT ?GEN ?D-2-PLUS-1)))

  (:action PLAN-TO-COMMAND-AT-1-1-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHO-AT - CHARACTER
                      ?WHERE-AT - PLACE ?C-1 - COUNT ?C-1-PLUS-1 -
                      COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-COMMAND-AT-1-1-1
    :parameters (?WHO - CHARACTER ?LAMP - MAGIC-LAMP ?WHO-AT -
                      CHARACTER ?WHERE-AT - PLACE ?C-1 - COUNT
                      ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-AT ?WHO ?WHO-AT ?WHERE-AT)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action COMMAND-DEAD-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHO-DEAD - CHARACTER ?C-1 - COUNT ?C-1-LESS-1 -
                      COUNT ?D-2 - COUNT ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?WHO ?WHO-DEAD)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (ALIVE ?WHO)
                       (ALIVE ?GEN) (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN) (NOT (= ?WHO ?GEN))
                       (INTENTION-COUNT ?GEN ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-DEAD ?WHO ?WHO-DEAD))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (INTENDS-DEAD ?GEN ?WHO-DEAD)
                 (NOT (INTENTION-COUNT ?GEN ?D-2))
                 (INTENTION-COUNT ?GEN ?D-2-PLUS-1)))

  (:action PLAN-TO-COMMAND-DEAD-1-1-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHO-DEAD - CHARACTER
                      ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?WHO ?WHO-DEAD)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-COMMAND-DEAD-1-1-1
    :parameters (?WHO - CHARACTER ?LAMP - MAGIC-LAMP ?WHO-DEAD -
                      CHARACTER ?C-1 - COUNT ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-DEAD ?WHO ?WHO-DEAD)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action COMMAND-HAS-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHO-HAS - CHARACTER ?WHAT-HAS - THING ?C-1 -
                      COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                      ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (ALIVE ?WHO)
                       (ALIVE ?GEN) (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN) (NOT (= ?WHO ?GEN))
                       (INTENTION-COUNT ?GEN ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-HAS ?WHO ?WHO-HAS ?WHAT-HAS))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (INTENDS-HAS ?GEN ?WHO-HAS ?WHAT-HAS)
                 (NOT (INTENTION-COUNT ?GEN ?D-2))
                 (INTENTION-COUNT ?GEN ?D-2-PLUS-1)))

  (:action PLAN-TO-COMMAND-HAS-1-1-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHO-HAS - CHARACTER
                      ?WHAT-HAS - THING ?C-1 - COUNT ?C-1-PLUS-1 -
                      COUNT)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-COMMAND-HAS-1-1-1
    :parameters (?WHO - CHARACTER ?LAMP - MAGIC-LAMP ?WHO-HAS -
                      CHARACTER ?WHAT-HAS - THING ?C-1 - COUNT
                      ?C-1-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-HAS ?WHO ?WHO-HAS ?WHAT-HAS)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action COMMAND-LOVES-1
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?LAMP - MAGIC-LAMP
                      ?WHO-LOVES - HUMAN ?WHO-ELSE-LOVES - HUMAN ?C-1 -
                      COUNT ?C-1-LESS-1 - COUNT ?D-2 - COUNT
                      ?D-2-PLUS-1 - COUNT)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1-LESS-1 ?C-1) (ALIVE ?WHO)
                       (ALIVE ?GEN) (HAS ?WHO ?LAMP)
                       (CONTROLS ?WHO ?GEN) (NOT (= ?WHO ?GEN))
                       (INTENTION-COUNT ?GEN ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (NOT (INTENDS-LOVES ?WHO ?WHO-LOVES ?WHO-ELSE-LOVES))
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-LESS-1)
                 (INTENDS-LOVES ?GEN ?WHO-LOVES ?WHO-ELSE-LOVES)
                 (NOT (INTENTION-COUNT ?GEN ?D-2))
                 (INTENTION-COUNT ?GEN ?D-2-PLUS-1)))

  (:action PLAN-TO-COMMAND-LOVES-1-1-2
    :parameters (?WHO - CHARACTER ?GEN - GENIE ?WHO-LOVES - HUMAN
                      ?WHO-ELSE-LOVES - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                      - COUNT)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-CONTROLS ?WHO ?WHO ?GEN)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action PLAN-TO-COMMAND-LOVES-1-1-1
    :parameters (?WHO - CHARACTER ?LAMP - MAGIC-LAMP ?WHO-LOVES - HUMAN
                      ?WHO-ELSE-LOVES - HUMAN ?C-1 - COUNT ?C-1-PLUS-1
                      - COUNT)
    :precondition (AND (INTENDS-LOVES ?WHO ?WHO-LOVES ?WHO-ELSE-LOVES)
                       (INTENTION-COUNT ?WHO ?C-1)
                       (NEXT ?C-1 ?C-1-PLUS-1))
    :effect (AND (INTENDS-HAS ?WHO ?WHO ?LAMP)
                 (NOT (INTENTION-COUNT ?WHO ?C-1))
                 (INTENTION-COUNT ?WHO ?C-1-PLUS-1)))

  (:action FALL-IN-LOVE
    :parameters (?WHO - HUMAN ?WITH-WHO - HUMAN ?WHERE - PLACE ?D-2 -
                      COUNT ?D-2-PLUS-1 - COUNT)
    :precondition (AND (AT ?WHO ?WHERE) (AT ?WITH-WHO ?WHERE)
                       (ALIVE ?WHO) (SINGLE ?WHO) (ALIVE ?WITH-WHO)
                       (BEAUTIFUL ?WITH-WHO)
                       (INTENTION-COUNT ?WHO ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (LOVES ?WHO ?WITH-WHO)
                 (INTENDS-MARRIED-TO ?WHO ?WHO ?WITH-WHO)
                 (NOT (INTENTION-COUNT ?WHO ?D-2))
                 (INTENTION-COUNT ?WHO ?D-2-PLUS-1)))

  (:action FRIGHTEN
    :parameters (?FRIGHTER - MONSTER ?FRIGHTEE - CHARACTER ?WHERE -
                    PLACE ?D-2 - COUNT ?D-2-PLUS-1 - COUNT)
    :precondition (AND (AT ?FRIGHTER ?WHERE) (AT ?FRIGHTEE ?WHERE)
                       (ALIVE ?FRIGHTER) (SCARY ?FRIGHTER)
                       (ALIVE ?FRIGHTEE) (NOT (= ?FRIGHTER ?FRIGHTEE))
                       (INTENTION-COUNT ?FRIGHTEE ?D-2)
                       (NEXT ?D-2 ?D-2-PLUS-1))
    :effect (AND (INTENDS-DEAD ?FRIGHTEE ?FRIGHTER)
                 (NOT (INTENTION-COUNT ?FRIGHTEE ?D-2))
                 (INTENTION-COUNT ?FRIGHTEE ?D-2-PLUS-1)))

  )
